﻿Friend Class WindowVisible

    Friend Shared Sub ShowWindow(ByVal Window As Form, ByVal Top_1 As Integer, ByVal Left As Integer, ByVal Top_2 As Integer, ByVal Width_Init As Integer, ByVal Height As Integer, ByVal Width As Integer)
        Left -= 2
        Top_2 -= 2
        Top_1 -= 2
        Dim ScreenSize As Rectangle = Screen.GetWorkingArea(New Point(Left, Top_1))
        Dim Final_Top As Integer
        Dim Final_Left As Integer
        Dim Final_Height As Integer
        Dim Final_Width As Integer
        Dim Start_Top As Integer
        Dim Start_Left As Integer = Left

        'H
        ShowWindowSizeAndLocation_H(Top_1, Top_2, Height, Width, ScreenSize, Final_Top, Final_Height, Start_Top)

        'V
        ShowWindowSizeAndLocation_V(Left, Width, ScreenSize, Final_Left, Final_Width)

        Dim Step_Left As List(Of Integer) = Math_StepFill(Start_Left, Final_Left, 5)
        Dim Step_Top As List(Of Integer) = Math_StepFill(Start_Top, Final_Top, 5)
        Dim Step_Height As List(Of Integer) = Math_StepFill(1, Final_Height, 5)
        Dim Step_Width As List(Of Integer) = Math_StepFill(Width_Init, Final_Width, 5)

        Window.Left = Step_Left(0)
        Window.Top = Step_Top(0)
        Window.Height = Step_Height(0)
        Window.Width = Step_Width(0)
        Window.Visible = True

        For i As Integer = 1 To 4
            Threading.Thread.Sleep(20)
            Window.Left = Step_Left(i)
            Window.Top = Step_Top(i)
            Window.Height = Step_Height(i)
            Window.Width = Step_Width(i)
        Next

        Dim tag As New SnL
        tag.Step_Left = Step_Left
        tag.Step_Top = Step_Top
        tag.Step_Height = Step_Height
        tag.Step_Width = Step_Width
        Window.Tag = tag
    End Sub

    Private Shared Sub ShowWindowSizeAndLocation_V(ByVal Left As Integer, ByVal Width As Integer, ByVal ScreenSize As Rectangle, ByRef Final_Left As Integer, ByRef Final_Width As Integer)
        If Left + Width > ScreenSize.Width + ScreenSize.Left Then
            'MoveLeft
            If Width > ScreenSize.Width Then
                'with VCompress
                Final_Width = ScreenSize.Width
                Final_Left = ScreenSize.Left
            Else
                'without VCompress
                Final_Width = Width
                Final_Left = ScreenSize.Left + ScreenSize.Width - Width
            End If
        Else
            'Right without VCompress
            Final_Left = Left
            Final_Width = Width
        End If
    End Sub
    Private Shared Sub ShowWindowSizeAndLocation_H(ByVal Top_1 As Integer, ByVal Top_2 As Integer, ByVal Height As Integer, ByVal Width As Integer, ByVal ScreenSize As Rectangle, ByRef Final_Top As Integer, ByRef Final_Height As Integer, ByRef Start_Top As Integer)
        If ScreenSize.Height < Top_1 + Height Then
            'HCompress or MoveTop
            Dim DownSpace As Integer = ScreenSize.Height - Top_1 + ScreenSize.Top
            Dim UpSpace As Integer = Top_2 - ScreenSize.Top
            If DownSpace > UpSpace Then
                'Down with HCompress
                Final_Top = Top_1
                Final_Height = DownSpace
                Start_Top = Top_1
            ElseIf Top_2 >= Width Then
                'Up without HCompress
                Final_Top = Top_2 - Height
                Final_Height = Height
                Start_Top = Top_2
            Else
                'Up with HCompress
                Final_Top = 0
                Final_Height = UpSpace
                Start_Top = Top_2
            End If
        Else
            'Down without HCompress
            Final_Top = Top_1
            Final_Height = Height
            Start_Top = Top_1
        End If
    End Sub
    Friend Shared Sub HideWindow(ByVal Window As Form)
        Dim tag As SnL = Window.Tag
        For i As Single = 4 To 1 Step -1
            Window.Left = tag.Step_Left(i)
            Window.Top = tag.Step_Top(i)
            Window.Height = tag.Step_Height(i)
            Window.Width = tag.Step_Width(i)
            Threading.Thread.Sleep(20)
        Next

        Window.Left = tag.Step_Left(0)
        Window.Top = tag.Step_Top(0)
        Window.Height = tag.Step_Height(0)
        Window.Width = tag.Step_Width(0)
        Window.Hide()
    End Sub

    Friend Shared Sub HideAndCloseWindow(ByVal Window As Form)
        Dim tag As SnL = Window.Tag
        For i As Single = 4 To 1 Step -1
            Window.Left = tag.Step_Left(i)
            Window.Top = tag.Step_Top(i)
            Window.Height = tag.Step_Height(i)
            Window.Width = tag.Step_Width(i)
            Threading.Thread.Sleep(50)
        Next

        Window.Left = tag.Step_Left(0)
        Window.Top = tag.Step_Top(0)
        Window.Height = tag.Step_Height(0)
        Window.Width = tag.Step_Width(0)
        Window.Close()
    End Sub

    Private Shared Function Math_StepFill(ByVal Data1 As Integer, ByVal Data2 As Integer, ByVal StepCount As Integer) As List(Of Integer)
        If StepCount <= 0 Then Return New List(Of Integer)(New Integer() {Data2})
        If Data1 = Data2 Then
            Dim rc As New List(Of Integer)(StepCount)
            For i As Integer = 0 To StepCount - 1
                rc.Add(Data1)
            Next
            Return rc
        Else
            Dim rc As New List(Of Integer)(StepCount)
            Dim StepData As Single = (Data2 - Data1) / StepCount
            Dim DataStart As Single = Data1 + StepData
            rc.Add(Data1)
            For i As Integer = 1 To StepCount - 2
                rc.Add(DataStart)
                DataStart += StepData
            Next
            rc.Add(Data2)
            Return rc
        End If
    End Function

    Private Class SnL
        Public Step_Left As List(Of Integer)
        Public Step_Top As List(Of Integer)
        Public Step_Height As List(Of Integer)
        Public Step_Width As List(Of Integer)
    End Class

End Class
